package com.njcn.csdevice.utils;

import cn.hutool.core.util.StrUtil;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.EnumUtils;
import com.njcn.csdevice.enums.AlgorithmResponseEnum;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * @author hongawen
 * @version 1.0.0
 * @date 2021年05月26日 17:17
 */
public class CsDeviceEnumUtil {

    /**
     * 获取UserResponseEnum实例
     */
    public static AlgorithmResponseEnum getResponseEnumByMessage(@NotNull Object value) {
        AlgorithmResponseEnum algorithmResponseEnum;
        try {
            String message = value.toString();
            if(message.indexOf(StrUtil.C_COMMA)>0){
                value = message.substring(message.indexOf(StrUtil.C_COMMA)+1);
            }
            algorithmResponseEnum = EnumUtils.valueOf(AlgorithmResponseEnum.class, value, AlgorithmResponseEnum.class.getMethod(BusinessException.GET_MESSAGE_METHOD));
            return Objects.isNull(algorithmResponseEnum) ? AlgorithmResponseEnum.CS_DEVICE_COMMON_ERROR : algorithmResponseEnum;
        } catch (NoSuchMethodException e) {
            throw new BusinessException(CommonResponseEnum.INTERNAL_ERROR);
        }
    }
    public static Enum<?> getExceptionEnum(HttpResult<Object> result){
        //如果返回错误，且为内部错误，则直接抛出异常
        CommonResponseEnum commonResponseEnum = EnumUtils.getCommonResponseEnumByCode(result.getCode());
        if (commonResponseEnum == CommonResponseEnum.CS_DEVICE_RESPONSE_ENUM) {
            return getResponseEnumByMessage(result.getMessage());
        }
        return commonResponseEnum;
    }
}
